Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.cc	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.cc	(revision 8154)
@@ -1,3 +1,5 @@
 /* ======================================================================== *\
+! $Name: not supported by cvs2svn $:$Id: MExtractTimeAndChargeSpline.cc,v 1.61 2006-10-24 08:24:52 tbretz Exp $
+! --------------------------------------------------------------------------
 !
 ! *
@@ -15,7 +17,8 @@
 ! *
 !
-!   Author(s): Markus Gaug       09/2004 <mailto:markus@ifae.es> 
+!   Author(s): Thomas Bretz <mailto:tbretz@astro.uni-wuerzbrug.de>
+!   Author(s): Markus Gaug 09/2004 <mailto:markus@ifae.es>
 !
-!   Copyright: MAGIC Software Development, 2002-2004
+!   Copyright: MAGIC Software Development, 2002-2006
 !
 !
@@ -142,4 +145,6 @@
 #include "MExtractTimeAndChargeSpline.h"
 
+#include "MExtralgoSpline.h"
+
 #include "MPedestalPix.h"
 
@@ -156,9 +161,9 @@
 const Byte_t  MExtractTimeAndChargeSpline::fgLoGainLast       = 14;
 const Float_t MExtractTimeAndChargeSpline::fgResolution       = 0.05;
-const Float_t MExtractTimeAndChargeSpline::fgRiseTimeHiGain   = 0.5;
-const Float_t MExtractTimeAndChargeSpline::fgFallTimeHiGain   = 0.5;
+const Float_t MExtractTimeAndChargeSpline::fgRiseTimeHiGain   = 0.7;
+const Float_t MExtractTimeAndChargeSpline::fgFallTimeHiGain   = 1.0;
 const Float_t MExtractTimeAndChargeSpline::fgLoGainStretch    = 1.5;
 const Float_t MExtractTimeAndChargeSpline::fgOffsetLoGain     = 1.3;
-const Float_t MExtractTimeAndChargeSpline::fgLoGainStartShift = -2.4;
+//const Float_t MExtractTimeAndChargeSpline::fgLoGainStartShift = -2.4;
 
 // --------------------------------------------------------------------------
@@ -177,6 +182,5 @@
 //
 MExtractTimeAndChargeSpline::MExtractTimeAndChargeSpline(const char *name, const char *title) 
-    : fAbMax(0.), fAbMaxPos(0.), fHalfMax(0.), 
-      fRandomIter(0), fExtractionType(kIntegral)
+    : fRandomIter(0), fExtractionType(kIntegral)
 {
 
@@ -187,5 +191,5 @@
   SetLoGainStretch();
   SetOffsetLoGain(fgOffsetLoGain);
-  SetLoGainStartShift(fgLoGainStartShift);
+//  SetLoGainStartShift(fgLoGainStartShift);
 
   SetRiseTimeHiGain();
@@ -310,7 +314,7 @@
 {
 
-  Int_t range = fHiGainLast - fHiGainFirst + 1 + fHiLoLast;
-
-  fHiGainSignal     .Set(range);
+  Int_t range = fHiGainLast - fHiGainFirst + 1;// + fHiLoLast;
+
+//  fHiGainSignal     .Set(range);
   fHiGainFirstDeriv .Set(range);
   fHiGainSecondDeriv.Set(range);
@@ -318,13 +322,13 @@
   range = fLoGainLast - fLoGainFirst + 1;
 
-  fLoGainSignal     .Set(range);
+//  fLoGainSignal     .Set(range);
   fLoGainFirstDeriv .Set(range);
   fLoGainSecondDeriv.Set(range);
 
-  fHiGainSignal     .Reset();
+//  fHiGainSignal     .Reset();
   fHiGainFirstDeriv .Reset();
   fHiGainSecondDeriv.Reset();
 
-  fLoGainSignal     .Reset();
+//  fLoGainSignal     .Reset();
   fLoGainFirstDeriv .Reset();
   fLoGainSecondDeriv.Reset();
@@ -361,362 +365,132 @@
 }
 
+void MExtractTimeAndChargeSpline::FindTimeAndChargeHiGain2(const Float_t *ptr, Int_t num,
+                                                           Float_t &sum, Float_t &dsum,
+                                                           Float_t &time, Float_t &dtime,
+                                                           Byte_t sat, Int_t maxpos)
+{
+    //    const Int_t range = fHiGainLast - fHiGainFirst + 1 + fHiLoLast;
+
+    // Do some handling if maxpos is last slice!
+
+    MExtralgoSpline s(ptr, num, fHiGainFirstDeriv.GetArray(), fHiGainSecondDeriv.GetArray());
+
+    s.SetRiseFallTime(fRiseTimeHiGain, fFallTimeHiGain);
+    s.SetResolution(fResolution);
+
+    if (IsNoiseCalculation())
+    {
+        if (fRandomIter == int(1./fResolution))
+            fRandomIter = 0;
+
+        sum = s.ExtractNoise(fRandomIter);
+        fRandomIter++;
+        return;
+    }
+
+    s.Extract(sat, maxpos);
+    s.GetTime(time, dtime);
+    s.GetSignal(sum, dsum);
+}
+
+void MExtractTimeAndChargeSpline::FindTimeAndChargeLoGain2(const Float_t *ptr, Int_t num,
+                                                           Float_t &sum,  Float_t &dsum,
+                                                           Float_t &time, Float_t &dtime,
+                                                           Byte_t sat, Int_t maxpos)
+{
+    MExtralgoSpline s(ptr, num, fLoGainFirstDeriv.GetArray(), fLoGainSecondDeriv.GetArray());
+
+    s.SetRiseFallTime(fRiseTimeLoGain, fFallTimeLoGain);
+    s.SetResolution(fResolution);
+
+    if (IsNoiseCalculation())
+    {
+        if (fRandomIter == int(1./fResolution))
+            fRandomIter = 0;
+
+        sum = s.ExtractNoise(fRandomIter);
+        return;
+    }
+
+    s.Extract(sat, maxpos);
+    s.GetTime(time, dtime);
+    s.GetSignal(sum, dsum);
+}
+
 // --------------------------------------------------------------------------
 //
-// Calculates the arrival time and charge for each pixel 
-//
-void MExtractTimeAndChargeSpline::FindTimeAndChargeHiGain(Byte_t *first, Byte_t *logain, Float_t &sum, Float_t &dsum, 
+// Calculates the arrival time and charge for each pixel
+//
+/*
+void MExtractTimeAndChargeSpline::FindTimeAndChargeHiGain(Byte_t *first, Byte_t *logain, Float_t &sum, Float_t &dsum,
                                                           Float_t &time, Float_t &dtime, 
                                                           Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag)
 {
-  Int_t range = fHiGainLast - fHiGainFirst + 1;
-  const Byte_t *end = first + range;
-  Byte_t       *p  = first;
-
-  sat = 0;
-  dsum = 0; // In all cases the extracted signal is valid
-
-  const Float_t pedes  = ped.GetPedestal();
-  const Float_t ABoffs = ped.GetPedestalABoffset();
-
-  const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
-
-  fAbMax         = 0.;
-  fAbMaxPos      = 0.;
-  fHalfMax       = 0.;
-  fMaxBinContent = 0;
-  Int_t  maxpos  = 0;
-
-  //
-  // Check for saturation in all other slices
-  //
-  Int_t ids = fHiGainFirst;
-  Float_t *sample = fHiGainSignal.GetArray();
-  while (p<end)
-    {
-
-      *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
-
-      if (*p > fMaxBinContent)
+    Int_t range = fHiGainLast - fHiGainFirst + 1;
+    const Byte_t *end = first + range;
+    Byte_t       *p  = first;
+
+    const Float_t pedes  = ped.GetPedestal();
+    const Float_t ABoffs = ped.GetPedestalABoffset();
+
+    const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
+
+    Byte_t maxcont = 0;
+    Int_t  maxpos  = 0;
+    sat = 0;
+
+    //
+    // Check for saturation in all other slices
+    //
+    Int_t ids = fHiGainFirst;
+    Float_t *sample = fHiGainSignal.GetArray();
+    while (p<end)
+    {
+        *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
+
+        if (*p > maxcont)
         {
-          maxpos = ids-fHiGainFirst-1;
-          // range-fWindowSizeHiGain+1 == fHiLoLast isn't it?
-          if (maxpos > 1 && maxpos < (range - fWindowSizeHiGain + 1))
-              fMaxBinContent = *p;
+            maxpos = ids-fHiGainFirst-1;
+            // range-fWindowSizeHiGain+1 == fHiLoLast isn't it?
+            //if (maxpos > 1 && maxpos < (range - fWindowSizeHiGain + 1))
+            if (maxpos > 1 && maxpos < (range-1*//* - fWindowSizeHiGain + 1*//*))
+                maxcont = *p;
         }
 
-      if (*p++ >= fSaturationLimit)
-        if (!sat)
-          sat = ids-fHiGainFirst;
-      
-    }
-  
-  if (fHiLoLast != 0)
-    {
-
-      end = logain + fHiLoLast;
-
-      while (logain<end)
+        if (*p++ >= fSaturationLimit)
+            if (!sat)
+                sat = ids-fHiGainFirst;
+    }
+
+    if (fHiLoLast != 0)
+    {
+        end = logain + fHiLoLast;
+
+        while (logain<end)
         {
-
-          *sample++ = (Float_t)*logain - pedmean[(ids++ + abflag) & 0x1];
-
-          if (*logain > fMaxBinContent)
-            { 
+            *sample++ = (Float_t)*logain - pedmean[(ids++ + abflag) & 0x1];
+
+            if (*logain > maxcont)
+            {
                 maxpos = ids-fHiGainFirst-1;
+
+                // FIXME!!! MUST BE THERE!
                 // range-fWindowSizeHiGain+1 == fHiLoLast isn't it?
                 //if (maxpos > 1 && maxpos < (range - fWindowSizeHiGain + 1))
-                //    fMaxBinContent = *logain;
+                //    maxcont = *logain;
             }
-          
-          if (*logain++ >= fSaturationLimit)
-            if (!sat)
-              sat = ids-fHiGainFirst;
-
-          range++;
+
+            if (*logain++ >= fSaturationLimit)
+                if (!sat)
+                    sat = ids-fHiGainFirst;
+
+            range++;
         }
     }
 
-  fAbMax = fHiGainSignal[maxpos];
-
-  fHiGainSecondDeriv[0] = 0.;
-  fHiGainFirstDeriv[0]  = 0.;
-
-  for (Int_t i=1;i<range-1;i++)
-    {
-      const Float_t pp = fHiGainSecondDeriv[i-1] + 4.;
-      fHiGainSecondDeriv[i] = -1.0/pp;
-      fHiGainFirstDeriv [i] = fHiGainSignal[i+1] - 2*fHiGainSignal[i] + fHiGainSignal[i-1];
-      fHiGainFirstDeriv [i] = (6.0*fHiGainFirstDeriv[i]-fHiGainFirstDeriv[i-1])/pp;
-    }
-
-  fHiGainSecondDeriv[range-1] = 0.;
-
-  for (Int_t k=range-2;k>=0;k--)
-    fHiGainSecondDeriv[k] = fHiGainSecondDeriv[k]*fHiGainSecondDeriv[k+1] + fHiGainFirstDeriv[k];
-  for (Int_t k=range-2;k>=0;k--)
-    fHiGainSecondDeriv[k] /= 6.;
-  
-  if (IsNoiseCalculation())
-    {
-
-      if (fRandomIter == int(1./fResolution))
-        fRandomIter = 0;
-      
-      const Float_t nsx = fRandomIter * fResolution;
-
-      if (fExtractionType == kAmplitude)
-        {
-          const Float_t b = nsx;
-          const Float_t a = 1. - nsx;
-          
-          sum = a*fHiGainSignal[1]
-            + b*fHiGainSignal[2]
-            + (a*a*a-a)*fHiGainSecondDeriv[1] 
-            + (b*b*b-b)*fHiGainSecondDeriv[2];
-        }
-      else
-          sum = CalcIntegralHiGain(2. + nsx, range);
-
-      fRandomIter++;
-      return;
-    }
-
-  //
-  // Allow no saturated slice and
-  // Don't start if the maxpos is too close to the limits.
-  //
-  const Bool_t limlo = maxpos <       TMath::Ceil(fRiseTimeHiGain);
-  const Bool_t limup = maxpos > range-TMath::Ceil(fFallTimeHiGain)-1;
-  if (sat || limlo || limup)
-    {
-      dtime = 1.0;
-      if (fExtractionType == kAmplitude)
-        {
-          sum  = fAbMax;
-          time = (Float_t)(fHiGainFirst + maxpos);
-          return;
-        }
-
-      sum  = CalcIntegralHiGain(limlo ? 0 : range, range);
-      time = (Float_t)(fHiGainFirst + maxpos - 1);
-      return;
-    }
-      
-  dtime = fResolution;
-
-  //
-  // Now find the maximum  
-  //
-  Float_t step    = 0.2; // start with step size of 1ns and loop again with the smaller one
-  Float_t lower   = -1. + maxpos;
-  Float_t upper   = (Float_t)maxpos;
-  fAbMaxPos       = upper;
-  Float_t x       = lower;
-  Float_t y       = 0.;
-  Float_t a       = 1.;
-  Float_t b       = 0.;
-  Int_t   klo     = maxpos-1;
-  Int_t   khi     = maxpos;
-
-  //
-  // Search for the maximum, starting in interval maxpos-1 in steps of 0.2 till maxpos-0.2.
-  // If no maximum is found, go to interval maxpos+1.
-  //
-  while ( x < upper - 0.3 )
-    {
-
-      x += step;
-      a -= step;
-      b += step;
-
-      y = a*fHiGainSignal[klo]
-        + b*fHiGainSignal[khi]
-        + (a*a*a-a)*fHiGainSecondDeriv[klo] 
-        + (b*b*b-b)*fHiGainSecondDeriv[khi];
-
-      if (y > fAbMax)
-        {
-          fAbMax    = y;
-          fAbMaxPos = x;
-        }
-
-    }
-
-  //
-  // Search for the absolute maximum from maxpos to maxpos+1 in steps of 0.2
-  //
-  if (fAbMaxPos > upper-0.1)
-    {
-      upper   = 1. + maxpos;
-      lower   = (Float_t)maxpos;
-      x       = lower;
-      a       = 1.;
-      b       = 0.;
-      khi     = maxpos+1;
-      klo     = maxpos;
-
-      while (x<upper-0.3)
-        {
-
-          x += step;
-          a -= step;
-          b += step;
-          
-          y = a*fHiGainSignal[klo]
-            + b*fHiGainSignal[khi]
-            + (a*a*a-a)*fHiGainSecondDeriv[klo] 
-            + (b*b*b-b)*fHiGainSecondDeriv[khi];
-
-          if (y > fAbMax)
-            {
-              fAbMax    = y;
-              fAbMaxPos = x;
-            }
-        }
-  }
-  //
-  // Now, the time, abmax and khicont and klocont are set correctly within the previous precision.
-  // Try a better precision. 
-  //
-  const Float_t up = fAbMaxPos+step - 3.0*fResolution;
-  const Float_t lo = fAbMaxPos-step + 3.0*fResolution;
-  const Float_t maxpossave = fAbMaxPos;
-  
-  x     = fAbMaxPos;
-  a     = upper - x;
-  b     = x - lower;
- 
-  step  = 2.*fResolution; // step size of 0.1 FADC slices
- 
-  while (x<up)
-    {
-
-      x += step;
-      a -= step;
-      b += step;
-      
-      y = a*fHiGainSignal[klo]
-        + b*fHiGainSignal[khi]
-        + (a*a*a-a)*fHiGainSecondDeriv[klo] 
-        + (b*b*b-b)*fHiGainSecondDeriv[khi];
-      
-      if (y > fAbMax)
-        {
-          fAbMax    = y;
-          fAbMaxPos = x;
-        }
-    }
-
-  //
-  // Second, try from time down to time-0.2 in steps of fResolution.
-  //
-  x     = maxpossave;
-
-  //
-  // Test the possibility that the absolute maximum has not been found between
-  // maxpos and maxpos+0.05, then we have to look between maxpos-0.05 and maxpos
-  // which requires new setting of klocont and khicont
-  //
-  if (x < lower + fResolution)
-    {
-      klo--;
-      khi--;
-      upper -= 1.;
-      lower -= 1.;
-    }
-
-  a     = upper - x;
-  b     = x - lower;
-  
-  while (x>lo)
-    {
-
-      x -= step;
-      a += step;
-      b -= step;
-      
-      y = a*fHiGainSignal[klo]
-        + b*fHiGainSignal[khi]
-        + (a*a*a-a)*fHiGainSecondDeriv[klo] 
-        + (b*b*b-b)*fHiGainSecondDeriv[khi];
-      
-      if (y > fAbMax)
-        {
-          fAbMax    = y;
-          fAbMaxPos = x;
-        }
-    }
-
-  if (fExtractionType == kAmplitude)
-    {
-      time  = fAbMaxPos + (Int_t)fHiGainFirst;
-      sum   = fAbMax;
-      return;
-    }
-
-  fHalfMax = fAbMax/2.;
-  
-  //
-  // Now, loop from the maximum bin leftward down in order to find the position of the half maximum.
-  // First, find the right FADC slice:
-  // 
-  klo  = maxpos;
-  while (klo > 0)
-    {
-      if (fHiGainSignal[--klo] < fHalfMax)
-        break;
-    }
-  
-  khi = klo+1;
-  //
-  // Loop from the beginning of the slice upwards to reach the fHalfMax:
-  // With means of bisection:
-  // 
-  x     = (Float_t)klo;
-  a     = 1.;
-  b     = 0.;
-  
-  step = 0.5;
-  Bool_t back = kFALSE;
-  
-  Int_t maxcnt = 20;
-  Int_t cnt    = 0;
-  
-  while (TMath::Abs(y-fHalfMax) > fResolution)
-    {
-      
-      if (back)
-        {
-          x -= step;
-          a += step;
-          b -= step;
-        }
-      else
-        {
-          x += step;
-          a -= step;
-          b += step;
-        }
-      
-      y = a*fHiGainSignal[klo]
-        + b*fHiGainSignal[khi]
-        + (a*a*a-a)*fHiGainSecondDeriv[klo] 
-        + (b*b*b-b)*fHiGainSecondDeriv[khi];
-      
-      back = y > fHalfMax;
-      
-      if (++cnt > maxcnt)
-        break;
-      
-      step /= 2.;
-    }
-  
-  //
-  // Now integrate the whole thing!
-  // 
-  time = (Float_t)fHiGainFirst + x;
-  sum  = CalcIntegralHiGain(fAbMaxPos - fRiseTimeHiGain, range);
-}
-
+    FindTimeAndChargeHiGain2(fHiGainSignal.GetArray(), range,
+                             sum, dsum, time, dtime,
+                             sat, maxpos);
+}
 
 // --------------------------------------------------------------------------
@@ -728,425 +502,40 @@
                                                           Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag) 
 {
-  Int_t range = fLoGainLast - fLoGainFirst + 1;
-  const Byte_t *end = first + range;
-  Byte_t       *p  = first;
-
-  const Float_t pedes  = ped.GetPedestal();
-  const Float_t ABoffs = ped.GetPedestalABoffset();
-
-  const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
-
-  fAbMax        = 0.;
-  fAbMaxPos     = 0.;
-  Int_t  maxpos = 0;
-  Int_t  max    = -9999;
-
-  dsum = 0; // In all cases the extracted signal is valid
-
-  //
-  // Check for saturation in all other slices
-  //
-  Int_t    ids    = fLoGainFirst;
-  Float_t *sample = fLoGainSignal.GetArray();
-  while (p<end)
-    {
-
-      *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
-
-      if (*p > max)
+    Int_t range = fLoGainLast - fLoGainFirst + 1;
+    const Byte_t *end = first + range;
+    Byte_t       *p  = first;
+
+    const Float_t pedes  = ped.GetPedestal();
+    const Float_t ABoffs = ped.GetPedestalABoffset();
+
+    const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
+
+    Int_t  maxpos = 0;
+    Int_t  max    = -9999;
+
+    //
+    // Check for saturation in all other slices
+    //
+    Int_t    ids    = fLoGainFirst;
+    Float_t *sample = fLoGainSignal.GetArray();
+    while (p<end)
+    {
+        *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
+
+        if (*p > max)
         {
-          maxpos = ids-fLoGainFirst-1;
-          max    = *p;
+            maxpos = ids-fLoGainFirst-1;
+            max    = *p;
         }
 
-      if (*p++ >= fSaturationLimit)
-        sat++;
-    }
-  
-  fAbMax = fLoGainSignal[maxpos];
-  
-  fLoGainSecondDeriv[0] = 0.;
-  fLoGainFirstDeriv[0]  = 0.;
-
-  for (Int_t i=1;i<range-1;i++)
-    {
-      const Float_t pp = fLoGainSecondDeriv[i-1] + 4.;
-      fLoGainSecondDeriv[i] = -1.0/pp;
-      fLoGainFirstDeriv [i] = fLoGainSignal[i+1] - 2*fLoGainSignal[i] + fLoGainSignal[i-1];
-      fLoGainFirstDeriv [i] = (6.0*fLoGainFirstDeriv[i]-fLoGainFirstDeriv[i-1])/pp;
-    }
-
-  fLoGainSecondDeriv[range-1] = 0.;
-
-  for (Int_t k=range-2;k>=0;k--)
-    fLoGainSecondDeriv[k] = fLoGainSecondDeriv[k]*fLoGainSecondDeriv[k+1] + fLoGainFirstDeriv[k];
-  for (Int_t k=range-2;k>=0;k--)
-    fLoGainSecondDeriv[k] /= 6.;
-  
-  if (IsNoiseCalculation())
-    {
-      if (fRandomIter == int(1./fResolution))
-        fRandomIter = 0;
-      
-      const Float_t nsx = fRandomIter * fResolution;
-
-      if (fExtractionType == kAmplitude)
-        {
-          const Float_t b = nsx;
-          const Float_t a = 1. - nsx;
-          
-          sum = a*fLoGainSignal[1]
-            + b*fLoGainSignal[2]
-            + (a*a*a-a)*fLoGainSecondDeriv[1] 
-            + (b*b*b-b)*fLoGainSecondDeriv[2];
-        }
-      else
-          sum = CalcIntegralLoGain(2. + nsx, range);
-
-      fRandomIter++;
-      return;
-    }
-  //
-  // Allow no saturated slice and
-  // Don't start if the maxpos is too close to the limits.
-  //
-  const Bool_t limlo = maxpos <       TMath::Ceil(fRiseTimeLoGain);
-  const Bool_t limup = maxpos > range-TMath::Ceil(fFallTimeLoGain)-1;
-  if (sat || limlo || limup)
-    {
-      dtime = 1.0;
-      if (fExtractionType == kAmplitude)
-        {
-          time = (Float_t)(fLoGainFirst + maxpos);
-          sum = fAbMax;
-          return;
-        }
-
-      sum  = CalcIntegralLoGain(limlo ? 0 : range, range);
-      time = (Float_t)(fLoGainFirst + maxpos - 1);
-      return;
-    }
-
-  dtime = fResolution;
-
-  //
-  // Now find the maximum  
-  //
-  Float_t step    = 0.2; // start with step size of 1ns and loop again with the smaller one
-  Float_t lower   = -1. + maxpos;
-  Float_t upper   = (Float_t)maxpos;
-  fAbMaxPos       = upper;
-  Float_t x       = lower;
-  Float_t y       = 0.;
-  Float_t a       = 1.;
-  Float_t b       = 0.;
-  Int_t   klo     = maxpos-1;
-  Int_t   khi     = maxpos;
-
-  //
-  // Search for the maximum, starting in interval maxpos-1 in steps of 0.2 till maxpos-0.2.
-  // If no maximum is found, go to interval maxpos+1.
-  //
-  while ( x < upper - 0.3 )
-    {
-
-      x += step;
-      a -= step;
-      b += step;
-
-      y = a*fLoGainSignal[klo]
-        + b*fLoGainSignal[khi]
-        + (a*a*a-a)*fLoGainSecondDeriv[klo] 
-        + (b*b*b-b)*fLoGainSecondDeriv[khi];
-
-      if (y > fAbMax)
-        {
-          fAbMax    = y;
-          fAbMaxPos = x;
-        }
-
-    }
-
-  //
-  // Test the possibility that the absolute maximum has not been found before the 
-  // maxpos and search from maxpos to maxpos+1 in steps of 0.2
-  //
-  if (fAbMaxPos > upper-0.1)
-    {
-
-      upper   = 1. + maxpos;
-      lower   = (Float_t)maxpos;
-      x       = lower;
-      a       = 1.;
-      b       = 0.;
-      khi     = maxpos+1;
-      klo     = maxpos;
-
-      while (x<upper-0.3)
-        {
-
-          x += step;
-          a -= step;
-          b += step;
-          
-          y = a*fLoGainSignal[klo]
-            + b*fLoGainSignal[khi]
-            + (a*a*a-a)*fLoGainSecondDeriv[klo] 
-            + (b*b*b-b)*fLoGainSecondDeriv[khi];
-
-          if (y > fAbMax)
-            {
-              fAbMax    = y;
-              fAbMaxPos = x;
-            }
-        }
-  }
-
-
-  //
-  // Now, the time, abmax and khicont and klocont are set correctly within the previous precision.
-  // Try a better precision. 
-  //
-  const Float_t up = fAbMaxPos+step - 3.0*fResolution;
-  const Float_t lo = fAbMaxPos-step + 3.0*fResolution;
-  const Float_t maxpossave = fAbMaxPos;
-  
-  x     = fAbMaxPos;
-  a     = upper - x;
-  b     = x - lower;
- 
-  step  = 2.*fResolution; // step size of 0.1 FADC slice
- 
-  while (x<up)
-    {
-
-      x += step;
-      a -= step;
-      b += step;
-      
-      y = a*fLoGainSignal[klo]
-        + b*fLoGainSignal[khi]
-        + (a*a*a-a)*fLoGainSecondDeriv[klo] 
-        + (b*b*b-b)*fLoGainSecondDeriv[khi];
-      
-      if (y > fAbMax)
-        {
-          fAbMax    = y;
-          fAbMaxPos = x;
-        }
-    }
-
-  //
-  // Second, try from time down to time-0.2 in steps of 0.025.
-  //
-  x     = maxpossave;
-
-  //
-  // Test the possibility that the absolute maximum has not been found between
-  // maxpos and maxpos+0.05, then we have to look between maxpos-0.05 and maxpos
-  // which requires new setting of klocont and khicont
-  //
-  if (x < lower + fResolution)
-    {
-      klo--;
-      khi--;
-      upper -= 1.;
-      lower -= 1.;
-    }
-
-  a     = upper - x;
-  b     = x - lower;
-  
-  while (x>lo)
-    {
-
-      x -= step;
-      a += step;
-      b -= step;
-      
-      y = a*fLoGainSignal[klo]
-        + b*fLoGainSignal[khi]
-        + (a*a*a-a)*fLoGainSecondDeriv[klo] 
-        + (b*b*b-b)*fLoGainSecondDeriv[khi];
-      
-      if (y > fAbMax)
-        {
-          fAbMax    = y;
-          fAbMaxPos = x;
-        }
-    }
-
-  if (fExtractionType == kAmplitude)
-    {
-      time = fAbMaxPos + (Int_t)fLoGainFirst;
-      sum  = fAbMax;
-      return;
-    }
-  
-  fHalfMax = fAbMax/2.;
-  
-  //
-  // Now, loop from the maximum bin leftward down in order to find the position of the half maximum.
-  // First, find the right FADC slice:
-  // 
-  klo  = maxpos;
-  while (klo > 0)
-    {
-      klo--;
-      if (fLoGainSignal[klo] < fHalfMax)
-        break;
-    }
-  
-  khi = klo+1;
-  //
-  // Loop from the beginning of the slice upwards to reach the fHalfMax:
-  // With means of bisection:
-  // 
-  x     = (Float_t)klo;
-  a     = 1.;
-  b     = 0.;
-  
-  step = 0.5;
-  Bool_t back = kFALSE;
-  
-  Int_t maxcnt = 20;
-  Int_t cnt    = 0;
-  
-  while (TMath::Abs(y-fHalfMax) > fResolution)
-    {
-      
-      if (back)
-        {
-          x -= step;
-          a += step;
-          b -= step;
-        }
-      else
-        {
-          x += step;
-          a -= step;
-          b += step;
-        }
-      
-      y = a*fLoGainSignal[klo]
-        + b*fLoGainSignal[khi]
-        + (a*a*a-a)*fLoGainSecondDeriv[klo] 
-        + (b*b*b-b)*fLoGainSecondDeriv[khi];
-      
-      back = y > fHalfMax;
-      
-      if (++cnt > maxcnt)
-        break;
-      
-      step /= 2.;
-    }
-  
-  //
-  // Now integrate the whole thing!
-  // 
-  time = x + (Int_t)fLoGainFirst;
-  sum  = CalcIntegralLoGain(fAbMaxPos - fRiseTimeLoGain, range);
-}
-
-Float_t MExtractTimeAndChargeSpline::CalcIntegralHiGain(Float_t start, Float_t range) const
-{
-    // The number of steps is calculated directly from the integration
-    // window. This is the only way to ensure we are not dealing with
-    // numerical rounding uncertanties, because we always get the same
-    // value under the same conditions -- it might still be different on
-    // other machines!
-    const Float_t step  = 0.2;
-    const Float_t width = fRiseTimeHiGain+fFallTimeHiGain;
-    const Float_t max   = range-1 - (width+step);
-    const Int_t   num   = TMath::Nint(width/step);
-
-    // The order is important. In some cases (limlo-/limup-check) it can
-    // happen than max<0. In this case we start at 0
-    if (start > max)
-        start = max;
-    if (start < 0)
-        start = 0;
-
-    start += step/2;
-
-    Double_t sum = 0.;
-    for (Int_t i=0; i<num; i++)
-    {
-        const Float_t x = start+i*step;
-        const Int_t klo = (Int_t)TMath::Floor(x);
-        const Int_t khi = klo + 1;
-        // Note: if x is close to one integer number (= a FADC sample)
-        // we get the same result by using that sample as klo, and the
-        // next one as khi, or using the sample as khi and the previous
-        // one as klo (the spline is of course continuous). So we do not
-        // expect problems from rounding issues in the argument of
-        // Floor() above (we have noticed differences in roundings
-        // depending on the compilation options).
-
-        const Float_t a = khi - x; // Distance from x to next FADC sample
-        const Float_t b = x - klo; // Distance from x to previous FADC sample
-
-        sum += a*fHiGainSignal[klo]
-            +  b*fHiGainSignal[khi]
-            + (a*a*a-a)*fHiGainSecondDeriv[klo]
-            + (b*b*b-b)*fHiGainSecondDeriv[khi];
-
-        // FIXME? Perhaps the integral should be done analitically
-        // between every two FADC slices, instead of numerically
-    }
-
-    sum *= step; // Transform sum in integral
-    return sum;
-}
-
-Float_t MExtractTimeAndChargeSpline::CalcIntegralLoGain(Float_t start, Float_t range) const
-{
-    // The number of steps is calculated directly from the integration
-    // window. This is the only way to ensure we are not dealing with
-    // numerical rounding uncertanties, because we always get the same
-    // value under the same conditions -- it might still be different on
-    // other machines!
-    const Float_t step  = 0.2;
-    const Float_t width = fRiseTimeLoGain+fFallTimeLoGain;
-    const Float_t max   = range-1 - (width+step);
-    const Int_t   num   = TMath::Nint(width/step);
-
-    // The order is important. In some cases (limlo-/limup-check) it can
-    // happen that max<0. In this case we start at 0
-    if (start > max)
-        start = max;
-    if (start < 0)
-        start = 0;
-
-    start += step/2;
-
-    Double_t sum = 0.;
-    for (Int_t i=0; i<num; i++)
-    {
-        const Float_t x = start+i*step;
-        const Int_t klo = (Int_t)TMath::Floor(x);
-        const Int_t khi = klo + 1;
-        // Note: if x is close to one integer number (= a FADC sample)
-        // we get the same result by using that sample as klo, and the
-        // next one as khi, or using the sample as khi and the previous
-        // one as klo (the spline is of course continuous). So we do not
-        // expect problems from rounding issues in the argument of
-        // Floor() above (we have noticed differences in roundings
-        // depending on the compilation options).
-
-        const Float_t a = khi - x; // Distance from x to next FADC sample
-        const Float_t b = x - klo; // Distance from x to previous FADC sample
-
-        sum += a*fLoGainSignal[klo]
-            +  b*fLoGainSignal[khi]
-            + (a*a*a-a)*fLoGainSecondDeriv[klo]
-            + (b*b*b-b)*fLoGainSecondDeriv[khi];
-
-        // FIXME? Perhaps the integral should be done analitically
-        // between every two FADC slices, instead of numerically
-    }
-    sum *= step; // Transform sum in integral
-    return sum;
-}
+        if (*p++ >= fSaturationLimit)
+            sat++;
+    }
+
+    FindTimeAndChargeLoGain2(fLoGainSignal.GetArray(), range,
+                             sum, dsum, time, dtime,
+                             sat, maxpos);
+}
+*/
 
 // --------------------------------------------------------------------------
@@ -1198,6 +587,3 @@
 
   return MExtractTimeAndCharge::ReadEnv(env, prefix, print) ? kTRUE : rc;
-
-}
-
-
+}
